#define _GNU_SOURCE
#include <assert.h>
#include <stdio.h>
#include <pthread.h>
#include <unistd.h>

#define N 64

static void *
func(void *arg)
{
	(void)arg;
	while (1) {
		sleep(1);
	}
}

int
main(void)
{
	int eno;
	pthread_t td;
	pthread_attr_t attr;
	void *ptr;
	size_t n;
	cpu_set_t *c;
	cpu_set_t *c2;
	int i;

	c = CPU_ALLOC(N);
	assert(c != NULL);

	c2 = CPU_ALLOC(N);
	assert(c2 != NULL);

	eno = pthread_attr_init(&attr);
	assert(eno == 0);

	for (i = 0; i < N; ++i) {
		CPU_SET_S(i, CPU_ALLOC_SIZE(N), c);
	}

	eno = pthread_attr_setaffinity_np(&attr, CPU_ALLOC_SIZE(N), c);
	assert(eno == 0);

	eno = pthread_create(&td, &attr, func, NULL);
	assert(eno == 0);

	eno = pthread_attr_destroy(&attr);
	assert(eno == 0);

	eno = pthread_getattr_np(td, &attr);
	assert(eno == 0);

	eno = pthread_attr_getstack(&attr, &ptr, &n);
	assert(eno == 0);

	printf("stack %p[%zu]\n", ptr, n);

	eno = pthread_attr_getaffinity_np(&attr, CPU_ALLOC_SIZE(N), c2);
	assert(eno == 0);

	for (i = 0; i < N; ++i) {
		printf("%i", CPU_ISSET_S(i, CPU_ALLOC_SIZE(N), c));
	}

	printf("\n");

	for (i = 0; i < N; ++i) {
		printf("%i", CPU_ISSET_S(i, CPU_ALLOC_SIZE(N), c2));
	}

	printf("\n");

	eno = pthread_attr_destroy(&attr);
	assert(eno == 0);

	CPU_FREE(c);
	CPU_FREE(c2);

	return 0;
}
